-- ==============================================================
-- RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
-- Version: 2019.1
-- Copyright (C) 1986-2019 Xilinx, Inc. All Rights Reserved.
-- 
-- ===========================================================

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity mcp2515_can_spi_spi_putc is
port (
    ap_clk : IN STD_LOGIC;
    ap_rst : IN STD_LOGIC;
    ap_start : IN STD_LOGIC;
    ap_done : OUT STD_LOGIC;
    ap_idle : OUT STD_LOGIC;
    ap_ready : OUT STD_LOGIC;
    din : IN STD_LOGIC_VECTOR (7 downto 0);
    keep_cs_n : IN STD_LOGIC_VECTOR (0 downto 0);
    spi_tx_data : OUT STD_LOGIC_VECTOR (7 downto 0);
    spi_tx_data_ap_vld : OUT STD_LOGIC;
    spi_keep_cs_n : OUT STD_LOGIC_VECTOR (0 downto 0);
    spi_keep_cs_n_ap_vld : OUT STD_LOGIC;
    spi_access_req : OUT STD_LOGIC_VECTOR (0 downto 0);
    spi_access_req_ap_vld : OUT STD_LOGIC;
    spi_access_ack : IN STD_LOGIC_VECTOR (0 downto 0);
    spi_rx_data : IN STD_LOGIC_VECTOR (7 downto 0);
    ap_return : OUT STD_LOGIC_VECTOR (7 downto 0) );
end;


architecture behav of mcp2515_can_spi_spi_putc is 
    constant ap_const_logic_1 : STD_LOGIC := '1';
    constant ap_const_logic_0 : STD_LOGIC := '0';
    constant ap_ST_fsm_state1 : STD_LOGIC_VECTOR (2 downto 0) := "000";
    constant ap_ST_fsm_state2 : STD_LOGIC_VECTOR (2 downto 0) := "001";
    constant ap_ST_fsm_state3 : STD_LOGIC_VECTOR (2 downto 0) := "010";
    constant ap_ST_fsm_state4 : STD_LOGIC_VECTOR (2 downto 0) := "011";
    constant ap_ST_fsm_state5 : STD_LOGIC_VECTOR (2 downto 0) := "100";
    constant ap_const_lv1_1 : STD_LOGIC_VECTOR (0 downto 0) := "1";
    constant ap_const_lv1_0 : STD_LOGIC_VECTOR (0 downto 0) := "0";
    constant ap_const_boolean_1 : BOOLEAN := true;

    signal ap_CS_fsm : STD_LOGIC_VECTOR (2 downto 0) := "000";
    signal retval_reg_86 : STD_LOGIC_VECTOR (7 downto 0);
    signal grp_read_fu_70_p2 : STD_LOGIC_VECTOR (0 downto 0);
    signal ap_NS_fsm : STD_LOGIC_VECTOR (2 downto 0);


begin




    ap_CS_fsm_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst = '1') then
                ap_CS_fsm <= ap_ST_fsm_state1;
            else
                ap_CS_fsm <= ap_NS_fsm;
            end if;
        end if;
    end process;

    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if ((ap_ST_fsm_state3 = ap_CS_fsm)) then
                retval_reg_86 <= spi_rx_data;
            end if;
        end if;
    end process;

    ap_NS_fsm_assign_proc : process (ap_start, ap_CS_fsm, grp_read_fu_70_p2)
    begin
        case ap_CS_fsm is
            when ap_ST_fsm_state1 => 
                if (((ap_ST_fsm_state1 = ap_CS_fsm) and (ap_start = ap_const_logic_1))) then
                    ap_NS_fsm <= ap_ST_fsm_state2;
                else
                    ap_NS_fsm <= ap_ST_fsm_state1;
                end if;
            when ap_ST_fsm_state2 => 
                if (((ap_ST_fsm_state2 = ap_CS_fsm) and (grp_read_fu_70_p2 = ap_const_lv1_1))) then
                    ap_NS_fsm <= ap_ST_fsm_state3;
                else
                    ap_NS_fsm <= ap_ST_fsm_state2;
                end if;
            when ap_ST_fsm_state3 => 
                ap_NS_fsm <= ap_ST_fsm_state4;
            when ap_ST_fsm_state4 => 
                ap_NS_fsm <= ap_ST_fsm_state5;
            when ap_ST_fsm_state5 => 
                if (((ap_ST_fsm_state5 = ap_CS_fsm) and (grp_read_fu_70_p2 = ap_const_lv1_0))) then
                    ap_NS_fsm <= ap_ST_fsm_state1;
                else
                    ap_NS_fsm <= ap_ST_fsm_state5;
                end if;
            when others =>  
                ap_NS_fsm <= "XXX";
        end case;
    end process;

    ap_done_assign_proc : process(ap_start, ap_CS_fsm, grp_read_fu_70_p2)
    begin
        if ((((ap_ST_fsm_state5 = ap_CS_fsm) and (grp_read_fu_70_p2 = ap_const_lv1_0)) or ((ap_ST_fsm_state1 = ap_CS_fsm) and (ap_start = ap_const_logic_0)))) then 
            ap_done <= ap_const_logic_1;
        else 
            ap_done <= ap_const_logic_0;
        end if; 
    end process;


    ap_idle_assign_proc : process(ap_start, ap_CS_fsm)
    begin
        if (((ap_ST_fsm_state1 = ap_CS_fsm) and (ap_start = ap_const_logic_0))) then 
            ap_idle <= ap_const_logic_1;
        else 
            ap_idle <= ap_const_logic_0;
        end if; 
    end process;


    ap_ready_assign_proc : process(ap_CS_fsm, grp_read_fu_70_p2)
    begin
        if (((ap_ST_fsm_state5 = ap_CS_fsm) and (grp_read_fu_70_p2 = ap_const_lv1_0))) then 
            ap_ready <= ap_const_logic_1;
        else 
            ap_ready <= ap_const_logic_0;
        end if; 
    end process;

    ap_return <= retval_reg_86;
    grp_read_fu_70_p2 <= spi_access_ack;

    spi_access_req_assign_proc : process(ap_CS_fsm)
    begin
        if ((ap_ST_fsm_state5 = ap_CS_fsm)) then 
            spi_access_req <= ap_const_lv1_0;
        elsif ((ap_ST_fsm_state2 = ap_CS_fsm)) then 
            spi_access_req <= ap_const_lv1_1;
        else 
            spi_access_req <= "X";
        end if; 
    end process;


    spi_access_req_ap_vld_assign_proc : process(ap_CS_fsm)
    begin
        if (((ap_ST_fsm_state5 = ap_CS_fsm) or (ap_ST_fsm_state2 = ap_CS_fsm))) then 
            spi_access_req_ap_vld <= ap_const_logic_1;
        else 
            spi_access_req_ap_vld <= ap_const_logic_0;
        end if; 
    end process;

    spi_keep_cs_n <= keep_cs_n;

    spi_keep_cs_n_ap_vld_assign_proc : process(ap_start, ap_CS_fsm)
    begin
        if (((ap_ST_fsm_state1 = ap_CS_fsm) and (ap_start = ap_const_logic_1))) then 
            spi_keep_cs_n_ap_vld <= ap_const_logic_1;
        else 
            spi_keep_cs_n_ap_vld <= ap_const_logic_0;
        end if; 
    end process;

    spi_tx_data <= din;

    spi_tx_data_ap_vld_assign_proc : process(ap_start, ap_CS_fsm)
    begin
        if (((ap_ST_fsm_state1 = ap_CS_fsm) and (ap_start = ap_const_logic_1))) then 
            spi_tx_data_ap_vld <= ap_const_logic_1;
        else 
            spi_tx_data_ap_vld <= ap_const_logic_0;
        end if; 
    end process;

end behav;
