// ==============================================================
// RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2019.1
// Copyright (C) 1986-2019 Xilinx, Inc. All Rights Reserved.
// 
// ===========================================================

`timescale 1 ns / 1 ps 

module mcp2515_can_spi_spi_putc (
        ap_clk,
        ap_rst,
        ap_start,
        ap_done,
        ap_idle,
        ap_ready,
        din,
        keep_cs_n,
        spi_tx_data,
        spi_tx_data_ap_vld,
        spi_keep_cs_n,
        spi_keep_cs_n_ap_vld,
        spi_access_req,
        spi_access_req_ap_vld,
        spi_access_ack,
        spi_rx_data,
        ap_return
);

parameter    ap_ST_fsm_state1 = 3'd0;
parameter    ap_ST_fsm_state2 = 3'd1;
parameter    ap_ST_fsm_state3 = 3'd2;
parameter    ap_ST_fsm_state4 = 3'd3;
parameter    ap_ST_fsm_state5 = 3'd4;

input   ap_clk;
input   ap_rst;
input   ap_start;
output   ap_done;
output   ap_idle;
output   ap_ready;
input  [7:0] din;
input  [0:0] keep_cs_n;
output  [7:0] spi_tx_data;
output   spi_tx_data_ap_vld;
output  [0:0] spi_keep_cs_n;
output   spi_keep_cs_n_ap_vld;
output  [0:0] spi_access_req;
output   spi_access_req_ap_vld;
input  [0:0] spi_access_ack;
input  [7:0] spi_rx_data;
output  [7:0] ap_return;

reg ap_done;
reg ap_idle;
reg ap_ready;
reg spi_tx_data_ap_vld;
reg spi_keep_cs_n_ap_vld;
reg[0:0] spi_access_req;
reg spi_access_req_ap_vld;

reg   [2:0] ap_CS_fsm;
reg   [7:0] retval_reg_86;
wire   [0:0] grp_read_fu_70_p2;
reg   [2:0] ap_NS_fsm;

// power-on initialization
initial begin
#0 ap_CS_fsm = 3'd0;
end

always @ (posedge ap_clk) begin
    if (ap_rst == 1'b1) begin
        ap_CS_fsm <= ap_ST_fsm_state1;
    end else begin
        ap_CS_fsm <= ap_NS_fsm;
    end
end

always @ (posedge ap_clk) begin
    if ((ap_ST_fsm_state3 == ap_CS_fsm)) begin
        retval_reg_86 <= spi_rx_data;
    end
end

always @ (*) begin
    if ((((ap_ST_fsm_state5 == ap_CS_fsm) & (grp_read_fu_70_p2 == 1'd0)) | ((ap_ST_fsm_state1 == ap_CS_fsm) & (ap_start == 1'b0)))) begin
        ap_done = 1'b1;
    end else begin
        ap_done = 1'b0;
    end
end

always @ (*) begin
    if (((ap_ST_fsm_state1 == ap_CS_fsm) & (ap_start == 1'b0))) begin
        ap_idle = 1'b1;
    end else begin
        ap_idle = 1'b0;
    end
end

always @ (*) begin
    if (((ap_ST_fsm_state5 == ap_CS_fsm) & (grp_read_fu_70_p2 == 1'd0))) begin
        ap_ready = 1'b1;
    end else begin
        ap_ready = 1'b0;
    end
end

always @ (*) begin
    if ((ap_ST_fsm_state5 == ap_CS_fsm)) begin
        spi_access_req = 1'd0;
    end else if ((ap_ST_fsm_state2 == ap_CS_fsm)) begin
        spi_access_req = 1'd1;
    end else begin
        spi_access_req = 'bx;
    end
end

always @ (*) begin
    if (((ap_ST_fsm_state5 == ap_CS_fsm) | (ap_ST_fsm_state2 == ap_CS_fsm))) begin
        spi_access_req_ap_vld = 1'b1;
    end else begin
        spi_access_req_ap_vld = 1'b0;
    end
end

always @ (*) begin
    if (((ap_ST_fsm_state1 == ap_CS_fsm) & (ap_start == 1'b1))) begin
        spi_keep_cs_n_ap_vld = 1'b1;
    end else begin
        spi_keep_cs_n_ap_vld = 1'b0;
    end
end

always @ (*) begin
    if (((ap_ST_fsm_state1 == ap_CS_fsm) & (ap_start == 1'b1))) begin
        spi_tx_data_ap_vld = 1'b1;
    end else begin
        spi_tx_data_ap_vld = 1'b0;
    end
end

always @ (*) begin
    case (ap_CS_fsm)
        ap_ST_fsm_state1 : begin
            if (((ap_ST_fsm_state1 == ap_CS_fsm) & (ap_start == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state2;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state1;
            end
        end
        ap_ST_fsm_state2 : begin
            if (((ap_ST_fsm_state2 == ap_CS_fsm) & (grp_read_fu_70_p2 == 1'd1))) begin
                ap_NS_fsm = ap_ST_fsm_state3;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state2;
            end
        end
        ap_ST_fsm_state3 : begin
            ap_NS_fsm = ap_ST_fsm_state4;
        end
        ap_ST_fsm_state4 : begin
            ap_NS_fsm = ap_ST_fsm_state5;
        end
        ap_ST_fsm_state5 : begin
            if (((ap_ST_fsm_state5 == ap_CS_fsm) & (grp_read_fu_70_p2 == 1'd0))) begin
                ap_NS_fsm = ap_ST_fsm_state1;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state5;
            end
        end
        default : begin
            ap_NS_fsm = 'bx;
        end
    endcase
end

assign ap_return = retval_reg_86;

assign grp_read_fu_70_p2 = spi_access_ack;

assign spi_keep_cs_n = keep_cs_n;

assign spi_tx_data = din;

endmodule //mcp2515_can_spi_spi_putc
